package io.hmit.modules.serviceOrder.controller;

import io.hmit.common.annotation.LogOperation;
import io.hmit.common.constant.Constant;
import io.hmit.common.page.PageData;
import io.hmit.common.utils.ExcelUtils;
import io.hmit.common.utils.Result;
import io.hmit.common.validator.AssertUtils;
import io.hmit.common.validator.ValidatorUtils;
import io.hmit.common.validator.group.AddGroup;
import io.hmit.common.validator.group.DefaultGroup;
import io.hmit.common.validator.group.UpdateGroup;
import io.hmit.modules.security.user.SecurityUser;
import io.hmit.modules.serviceOrder.dto.PensionOrganizationServiceDTO;
import io.hmit.modules.serviceOrder.dto.PensionServiceDTO;
import io.hmit.modules.serviceOrder.dto.PensionServiceDocumentDTO;
import io.hmit.modules.serviceOrder.excel.PensionServiceExcel;
import io.hmit.modules.serviceOrder.service.PensionOrganizationServiceService;
import io.hmit.modules.serviceOrder.service.PensionServiceDocumentService;
import io.hmit.modules.serviceOrder.service.PensionServiceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 服务表
 *
 * @author zsh 408538940@qq.com
 * @since 1.0.0 2021-01-26
 */
@RestController
@RequestMapping("serviceOrder/pensionservice")
@Api(tags="服务表")
public class PensionServiceController {
    @Autowired
    private PensionServiceService pensionServiceService;
    @Autowired
    private PensionServiceDocumentService pensionServiceDocumentService;

    @Autowired
    private PensionOrganizationServiceService pensionOrganizationServiceService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("serviceOrder:pensionservice:page")
    public Result<PageData<PensionServiceDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<PensionServiceDTO> page = pensionServiceService.page(params);

        return new Result<PageData<PensionServiceDTO>>().ok(page);
    }

    @GetMapping("getServiceList")
    @ApiOperation("获取服务list不分页")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "keyword", value = "查询字段，", paramType = "query", dataType="String"),
            @ApiImplicitParam(name = "serviceType", value = "服务类型", paramType = "query", dataType="String")
    })
    public Result<List<PensionServiceDTO>> getServiceList(@ApiIgnore @RequestParam Map<String, Object> params){
        List<PensionServiceDTO> pensionServiceDTOList = pensionServiceService.list(params);

        return new Result<List<PensionServiceDTO>>().ok(pensionServiceDTOList);
    }

    @GetMapping("getServiceTree")
    @ApiOperation("获取服务list不分页")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "keyword", value = "查询字段，", paramType = "query", dataType="String"),
            @ApiImplicitParam(name = "serviceType", value = "服务类型", paramType = "query", dataType="String")
    })
    public Result<List<PensionServiceDTO>> getServiceTree(@ApiIgnore @RequestParam Map<String, Object> params){
        List<PensionServiceDTO> pensionServiceDTOList = pensionServiceService.getServiceTree(params);

        return new Result<List<PensionServiceDTO>>().ok(pensionServiceDTOList);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("serviceOrder:pensionservice:info")
    public Result<PensionServiceDTO> get(@PathVariable("id") Long id){
        PensionServiceDTO data = pensionServiceService.get(id);
        //获取服务的轮播图
        Map<String,Object> param = new HashMap<>();
        param.put("serviceId",data.getId());
        List<PensionServiceDocumentDTO> pensionServiceDocumentDTOList = pensionServiceDocumentService.list(param);
        data.setPensionServiceDocumentDTOList(pensionServiceDocumentDTOList);
        return new Result<PensionServiceDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("serviceOrder:pensionservice:save")
    public Result save(@RequestBody PensionServiceDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        pensionServiceService.save(dto);

        PensionOrganizationServiceDTO pensionOrganizationServiceDTO = new PensionOrganizationServiceDTO();
        pensionOrganizationServiceDTO.setServiceId(dto.getId());
        pensionOrganizationServiceDTO.setOrganizationId(dto.getServiceOrgId());
        pensionOrganizationServiceDTO.setCreator(SecurityUser.getUserId());
        pensionOrganizationServiceService.save(pensionOrganizationServiceDTO);

        //保存服务详情页面的轮播图
        List<PensionServiceDocumentDTO> pensionServiceDocumentDTOList = dto.getPensionServiceDocumentDTOList();
        if(pensionServiceDocumentDTOList!=null){
            for (PensionServiceDocumentDTO pensionServiceDocumentDTO : pensionServiceDocumentDTOList) {
                pensionServiceDocumentDTO.setServiceId(dto.getId());
                pensionServiceDocumentService.save(pensionServiceDocumentDTO);
            }
        }


        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("serviceOrder:pensionservice:update")
    public Result update(@RequestBody PensionServiceDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        pensionServiceService.update(dto);
        pensionServiceDocumentService.deletebyServiceId(dto.getId());
        //保存服务详情页面的轮播图
        List<PensionServiceDocumentDTO> pensionServiceDocumentDTOList = dto.getPensionServiceDocumentDTOList();
        if(pensionServiceDocumentDTOList!=null){
            for (PensionServiceDocumentDTO pensionServiceDocumentDTO : pensionServiceDocumentDTOList) {
                pensionServiceDocumentDTO.setServiceId(dto.getId());
                pensionServiceDocumentService.save(pensionServiceDocumentDTO);
            }
        }

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("serviceOrder:pensionservice:delete")
    public Result delete(@RequestBody Long[] ids){
        //校验数据
        AssertUtils.isArrayEmpty(ids, "id");

        pensionServiceService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("serviceOrder:pensionservice:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<PensionServiceDTO> list = pensionServiceService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, PensionServiceExcel.class);
    }

}
